import { Element_ } from '../../../../../Class/Element';
import { Zoom } from '../../../../../client/zoom';
import { System } from '../../../../../system';
import { Dict } from '../../../../../types/Dict';
import { GraphClass } from '../../../../../types/GraphClass';
import { G } from '../../../../../types/interface/G';
export interface I<T> {
    style: Dict<string>;
    graph: G;
    disabled: boolean;
    fullwindow: boolean;
    frame: Element_;
    zoom: Zoom;
    controls: boolean;
}
export interface O<T> {
    graph: G | GraphClass;
}
export default class Editor<T> extends Element_<I<T>, O<T>> {
    __: string[];
    private _fallback_graph;
    private _graph;
    constructor(system: System);
    onRefInputInvalid(name: string): void;
    onRefInputData(name: string, data: any): void;
    onRefInputDrop(name: string): void;
    onRefOutputData(name: string, data: any): void;
    snapshotSelf(): Dict<any>;
    restoreSelf(state: Dict<any>): void;
}
